include masm32rt.inc
include gdip.inc
include gdiplus.inc
includelib gdiplus.lib
.686p
.mmx
.xmm

IDRS_IMAGE EQU 1234

WndProc 	proto :DWORD,:DWORD,:DWORD,:DWORD

WND_DATA struct
	hdc			HDC 	?
	hXBtn		HWND	?
	bDrag		DWORD	?
	pos			DWORD	?
WND_DATA ends

.data
	ClassName		db "MainClass32",0
	AppName			db "Main Window",0
.data?
	hInstance	dd ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG
LOCAL gsi:GdiplusStartupInput
LOCAL gtkn:PULONG

	mov gsi.GdiplusVersion,1
	mov gsi.DebugEventCallback,0
	mov gsi.SuppressBackgroundThread,0
	mov gsi.SuppressExternalCodecs,0
	invoke GdiplusStartup,ADDR gtkn,ADDR gsi,0

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,0
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,OFFSET ClassName
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,NULL,OFFSET ClassName,OFFSET AppName,WS_VISIBLE or WS_POPUP,1,1,1,1,NULL,NULL,hInstance,NULL)
	invoke ShowWindow,esi,SW_SHOWNORMAL
	invoke UpdateWindow,esi

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	
	invoke GdiplusShutdown,gtkn
	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL graphics:PVOID
LOCAL bitmap:PVOID
LOCAL bmpData:BitmapData
LOCAL rectf:RectF
LOCAL rect:RECT
LOCAL region:PVOID
LOCAL path:PVOID
LOCAL hRgn:HRGN
LOCAL pen:PVOID
LOCAL pt:POINT

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		invoke DeleteObject,rv(GetWindowLong,hWnd,WND_DATA.hdc)
	.elseif uMsg == WM_CREATE
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
		invoke DeleteObject,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,WND_DATA.hdc,ebx
		invoke GdipCreateFromHDC,ebx,ADDR graphics
		invoke GdipGraphicsClear,graphics,ColorsSkyBlue
		
		;/* load bitmap data */
		mov edx,rv(GetClassLong,hWnd,GCL_HMODULE)
		invoke GdipCreateBitmapFromResource,edx,IDRS_IMAGE,ADDR bitmap
		;invoke GdipCreateBitmapFromFile,ADDR wszImage,ADDR bitmap
		invoke GdipGetImageWidth,bitmap,ADDR rect.right
		invoke GdipGetImageHeight,bitmap,ADDR rect.bottom
		mov rect.left,0
		mov rect.top,0
		invoke GdipBitmapLockBits,bitmap,ADDR rect,ImageLockModeRead,PixelFormat32bppARGB,ADDR bmpData
		
		;/* center window */
		mov esi,rv(GetSystemMetrics,SM_CXSCREEN)
		mov edi,rv(GetSystemMetrics,SM_CYSCREEN)
		shr esi,1
		shr edi,1
		mov eax,bmpData.nWidth
		mov edx,bmpData.nHeight
		shr eax,1
		shr edx,1
		sub esi,eax
		sub edi,edx
		invoke SetWindowPos,hWnd,0,esi,edi,bmpData.nWidth,bmpData.nHeight,SWP_NOZORDER

		; create path of bitmap-data
		invoke GdipCreatePath,FillModeAlternate,ADDR path
		mov ebx,bmpData.Scan0
		xor edi,edi
		xor esi,esi
		.while edi < bmpData.nHeight
			xor esi,esi
			.while esi < bmpData.nWidth
				.if DWORD ptr [ebx+esi*4] != 0ffff0000h ; color = red
					invoke GdipAddPathRectangleI,path,esi,edi,1,1
				.endif
				.if DWORD ptr [ebx+esi*4] == 0ff0000ffh		; marker for X-Button
					mov pt.x,esi
					mov pt.y,edi
				.endif
				inc esi
			.endw
			add ebx,bmpData.Stride
			inc edi
		.endw
		invoke GdipBitmapUnlockBits,bitmap,ADDR bmpData
		
		;/* create rgion from path */
		invoke GdipCreateRegionPath,path,ADDR region
		invoke GdipGetRegionHRgn,region,graphics,ADDR hRgn
		;/* set new window region */
		invoke SetWindowRgn,hWnd,hRgn,1

		;/* draw the image */
		invoke GdipDrawImage,graphics,bitmap,0,0
		
		invoke GdipDisposeImage,bitmap
		invoke GdipDeletePath,path
		invoke GdipDeleteRegion,region
		invoke GdipDeleteGraphics,graphics
		
		;/* create X-Button */
		invoke GetClassLong,hWnd,GCL_HMODULE
		mov edx,pt.x
		mov ecx,pt.y
		sub edx,10
		sub ecx,10
		invoke SetWindowLong,hWnd,WND_DATA.hXBtn,rv(CreateWindowEx,0,"Button","X",BS_CENTER or WS_CHILD or WS_VISIBLE,edx,ecx,20,20,hWnd,0,eax,0)
	.elseif uMsg == WM_COMMAND
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hXBtn)
		.if ebx == lParam
			.if WORD ptr wParam+2 == BN_CLICKED
				invoke DestroyWindow,hWnd
				invoke PostQuitMessage,0
			.endif
		.endif
	.elseif uMsg == WM_LBUTTONDOWN
		invoke GetCursorPos,ADDR pt
		mov edx,pt.y
		shl edx,16
		or edx,pt.x
		invoke SetWindowLong,hWnd,WND_DATA.pos,edx
		invoke SetWindowLong,hWnd,WND_DATA.bDrag,1
		invoke SetCapture,hWnd
	.elseif uMsg == WM_LBUTTONUP
		invoke SetWindowLong,hWnd,WND_DATA.bDrag,0
		invoke ReleaseCapture
	.elseif uMsg == WM_MOUSEMOVE
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.bDrag)
		.if ebx
			mov ebx,rv(GetWindowLong,hWnd,WND_DATA.pos)
			invoke GetWindowRect,hWnd,ADDR rect
			invoke GetCursorPos,ADDR pt
			movzx ecx,bx
			mov edx,ebx
			shr edx,16
			mov eax,ecx
			mov ecx,pt.x
			sub ecx,eax
			mov eax,edx
			mov edx,pt.y
			sub edx,eax
			add rect.left,ecx
			add rect.top,edx
			invoke SetWindowPos,hWnd,0,rect.left,rect.top,0,0,SWP_NOSIZE or SWP_NOZORDER
			mov edx,pt.y
			shl edx,16
			or edx,pt.x
			invoke SetWindowLong,hWnd,WND_DATA.pos,edx
		.endif
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps	
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

end main
